import { Component, Input, OnInit } from "@angular/core";
import { CapabilityRequest } from "../../../../model/capability-request";
import { CapabilityLauncherService } from "../../../../services/capability-launcher.service";
import { CapabilityExecution } from "../../../../model/capability-execution";
import {CapabilityRequestService} from "../../../../services/capability-request.service";

@Component({
  selector: "app-request-operations",
  templateUrl: "./request-operations.component.html",
  styleUrls: ["./request-operations.component.scss"],
})
export class RequestOperationsComponent implements OnInit {
  @Input() capabilityRequest: CapabilityRequest;
  public capabilityExecution: CapabilityExecution;

  // Observer for submitting capability request objects (returns a capability execution)
  public submitRequestObserver = {
    next: (submitResponse: CapabilityExecution) => {
      this.capabilityExecution = submitResponse;
      window.location.reload();
    },
    error: (error) => {
      console.log(error);
    },
  };

  public followonRequestObserver = {
    next: (followonResponse: CapabilityRequest) => {
      if (followonResponse.id) {
        // Capability request created; ID found
        // Redirect to request status page
        this.capabilityRequestService.redirectToRequestStatusPage(followonResponse.id);
      }
    },
    error: (error) => {
      console.log(error);
    },
  };

  constructor(
    public capabilityLauncherService: CapabilityLauncherService,
    private capabilityRequestService: CapabilityRequestService,
  ) {}

  ngOnInit(): void {}
}
